%Define sample frequency
sf = 48000;

%Define pure tones for "instrument"
c3 = 130.81;
d3 = 146.83;
e3 = 164.81;
f3 = 174.61;
fs3 = 185.00;
g3 = 196.00;
a3 = 220.00;
as3 = 233.08;
b3 = 246.94;
c4 = 261.63;
d4 = 293.66;
e4 = 329.63;
f4 = 349.23;
fs4 = 369.99;
g4 = 392.00;
a4 = 440.00;
as4 = 466.16;
b4 = 493.88;

bassC = [c3 d3 e3 f3 g3 a3 b3];
bassF = [c3 d3 e3 f3 g3 as3 b3];
bassG = [c3 d3 e3 fs3 g3 a3 b3];

trebC = [c4 d4 e4 f4 g4 a4 b4];
trebF = [c4 d4 e4 f4 g4 as4 b4];
trebG = [c4 d4 e4 fs4 g4 a4 b4];

bassbars = [bassC ; bassC ; bassC ; bassC ; bassF ; bassF ; bassC ; bassC ; bassG ; bassF ; bassC ; bassC];
trebbars = [trebC ; trebC ; trebC ; trebC ; trebF ; trebF ; trebC ; trebC ; trebG ; trebF ; trebC ; trebC];

%Starting condition
start = [ 0 0 0 1 0 0 0];

%Wolfram's Rule 30 Treble
current = start;
history30 = [];
song30 = [];
for i=1:12
    new = [];
    for j=1:length(current)
        
        if j==1
            left = length(current);
            right = j+1;
        elseif j==length(current)
            left = j-1;
            right = 1;
        else
            left = j-1;
            right = j+1;
        end
        
        if ((current(left) == 1) && (current(j) == 1) && (current(right) == 1)) || ...
           ((current(left) == 1) && (current(j) == 1) && (current(right) == 0)) || ...
           ((current(left) == 1) && (current(j) == 0) && (current(right) == 1)) || ...
           ((current(left) == 0) && (current(j) == 0) && (current(right) == 0))
            new(j) = 0;
        else
            new(j) = 1;
        end
    end
    
    history30 = [history30 ; current];
    
    currentbar = trebbars(i,:);
    bar = [];
    count = sum(current);
    notedur = 1/count;
    for k=1:length(current)
        if current(k) == 1
            bar = [bar pureTone(currentbar(k),notedur)];
        end
    end
        
    song30 = [song30 bar];
    current = new;
end

imwrite(history30*255,'treble.png','png')
wavwrite(song30,sf,'treble.wav')

%Wolfram's Rule 90 Bass
current = start;
history90 = [];
song90 = [];
for i=1:12
    new = [];
    for j=1:length(current)
        
        if j==1
            left = length(current);
            right = j+1;
        elseif j==length(current)
            left = j-1;
            right = 1;
        else
            left = j-1;
            right = j+1;
        end
        
        if ((current(left) == 1) && (current(j) == 1) && (current(right) == 1)) || ...
           ((current(left) == 1) && (current(j) == 0) && (current(right) == 1)) || ...
           ((current(left) == 0) && (current(j) == 1) && (current(right) == 0)) || ...
           ((current(left) == 0) && (current(j) == 0) && (current(right) == 0))
            new(j) = 0;
        else
            new(j) = 1;
        end
    end
    
    history90 = [history90 ; current];
    
    currentbar = bassbars(i,:);
    bar = [];
    count = sum(current);
    notedur = 1/count;
    for k=1:length(current)
        if current(k) == 1
            bar = [bar pureTone(currentbar(k),notedur)];
        end
    end
    
    song90 = [song90 bar];
    current = new;
end

imwrite(history90*255,'rule90.png','png')
wavwrite(song90,sf,'bass.wav')

wavwrite((song90+song30)/2,sf,'12bar.wav')