% Generate enveloped pure tones.
% Enter at least 1 argument.
% Defaults are:
%  duration    1 sec
%  amplitude   1 
%  sampleFreq  48000 Hz

function s = pureTone (frequency, duration, amplitude, sampleFreq)

switch nargin  
case 0
    error('Enter a frequency.')
case 1
    duration   = 1;
    amplitude  = 1;
    sampleFreq = 48000;
    save2file  = 0;
case 2
    amplitude  = 1;
    sampleFreq = 48000;
    save2file  = 0;
case 3
    sampleFreq = 48000;
    save2file  = 0;
case 4
    save2file  = 0;
end


t = linspace( 0, duration, duration * sampleFreq );
s = amplitude * sin( 2 * pi * frequency * t );

e = [0:(1/(length(s)/5)):1 ones(1,3*(length(s)/5)-2) 1:-(1/(length(s)/5)):0];
s = s.*e;

end